#define MAIN
#include <globals.h>
#include "RTcmix.h"

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <stdlib.h>
extern "C" {
#include <GL/aux.h>
#include "3d.h"
}
#include <math.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <signal.h>


#define drawOneLine(x1,y1,z1,x2,y2,z2) glBegin(GL_LINES); \
	glVertex3d ((x1),(y1),(z1)); glVertex3d ((x2),(y2),(z2)); glEnd();


float xval;
float yval;
float zval;
float rval;
float xincr;
float yincr;
float zincr;
float rincr;

int moveit;

#define MYPORT (IPPORT_RESERVED + 78)

int ccounter,s; /* s is the socket */


struct pitchobj {
	float octpc;
	float pprob;
	float vvv[3];
	};

struct pitchobj pitches[6];

RTcmix *rrr;


void rright(AUX_EVENTREC *event)
{
	rincr += 1.0;
}

void rleft(AUX_EVENTREC *event)
{
	rincr -= 1.0;
}

void rstop(AUX_EVENTREC *event)
{
	rincr = 0.0;
}


void xup(AUX_EVENTREC *event)
{
	if (moveit) xincr -= 0.1;
	else xval -= 0.1;
}

void xdown(AUX_EVENTREC *event)
{
	if (moveit) xincr += 0.1;
	else xval += 0.1;
}

void yup(AUX_EVENTREC *event)
{
	if (moveit) yincr += 0.1;
	else yval += 0.1;
}

void ydown(AUX_EVENTREC *event)
{
	if (moveit) yincr -= 0.1;
	else yval -= 0.1;
}


void zup(AUX_EVENTREC *event)
{
	if (moveit) zincr -= 0.1;
	else zval -= 0.1;
}

void zdown(AUX_EVENTREC *event)
{
	if (moveit) zincr += 0.1;
	else zval += 0.1;
}

void homest(AUX_EVENTREC *event)
{
	xval = xincr = yincr = zincr = rval = rincr = 0.0;
	yval = 1.0;
	zval = 5.0;
	moveit = 0;
}

void movetoggle(AUX_EVENTREC *event)
{
	if (moveit) {
		moveit = 0;
		xincr = yincr = zincr = 0.0;
		}
	else moveit = 1;
}


void display(void) {}

void rdisplay(void)
{
	int i;
	GLdouble d1,tmpv[3];
	float cval1,cval2,cval3;
	float note,psum,tprob;
	float brrand(),choosenote(float);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	xval += xincr;
	yval += yincr;
	zval += zincr;
	rval += rincr;

	if (abs(xval) > 10.0) xincr = -xincr;
	if (abs(yval) > 10.0) yincr = -yincr;
	if (abs(zval) > 10.0) zincr = -zincr;


/*
printf("xval: %f   zval: %f   rval: %f\n",xval,zval,rval);
*/

	glPushMatrix();
		glRotatef(rval, 0.0, 1.0, 0.0);
		cval1 = 0.0;
		cval2 = 1.0;
		cval3 = 1.0;
		psum = 0.0;
		for (i = 0; i < 6; i++) {
			glPushMatrix();
				glColor3f(cval1, cval2, cval3);
				glTranslatef(pitches[i].vvv[0]-xval,
					pitches[i].vvv[1]-yval,
					pitches[i].vvv[2]-zval);
				auxSolidSphere(0.2);
				cval1 += 0.15;
				cval2 -= 0.15;
				if (cval3 > 0.0) cval3 = 0.0;
				else cval3 = 1.0;
			glPopMatrix();
			if (ccounter == 4) {
				tmpv[0] = pitches[i].vvv[0]-xval;
				tmpv[1] = pitches[i].vvv[1]-yval;
				tmpv[2] = pitches[i].vvv[2]-zval;
				tprob = 5.0 - length3(tmpv);
				if (tprob < 0.0) tprob = 0.1;
				pitches[i].pprob = psum + tprob;
				psum = pitches[i].pprob;
				}
			}

		glDisable(GL_LIGHTING);
		glColor3f(1.0, 1.0, 1.0);
		for (i = 1; i < 6; i++) {
			drawOneLine(pitches[0].vvv[0]-xval,
				pitches[0].vvv[1]-yval,
				pitches[0].vvv[2]-zval,
				pitches[i].vvv[0]-xval,
				pitches[i].vvv[1]-yval,
				pitches[i].vvv[2]-zval);
			}
		for (i = 2; i < 6; i++) {
			drawOneLine(pitches[1].vvv[0]-xval,
				pitches[1].vvv[1]-yval,
				pitches[1].vvv[2]-zval,
				pitches[i].vvv[0]-xval,
				pitches[i].vvv[1]-yval,
				pitches[i].vvv[2]-zval);
			}
		for (i = 3; i < 6; i++) {
			drawOneLine(pitches[2].vvv[0]-xval,
				pitches[2].vvv[1]-yval,
				pitches[2].vvv[2]-zval,
				pitches[i].vvv[0]-xval,
				pitches[i].vvv[1]-yval,
				pitches[i].vvv[2]-zval);
			}
		for (i = 4; i < 6; i++) {
			drawOneLine(pitches[3].vvv[0]-xval,
				pitches[3].vvv[1]-yval,
				pitches[3].vvv[2]-zval,
				pitches[i].vvv[0]-xval,
				pitches[i].vvv[1]-yval,
				pitches[i].vvv[2]-zval);
			}
		for (i = 5; i < 6; i++) {
			drawOneLine(pitches[4].vvv[0]-xval,
				pitches[4].vvv[1]-yval,
				pitches[4].vvv[2]-zval,
				pitches[i].vvv[0]-xval,
				pitches[i].vvv[1]-yval,
				pitches[i].vvv[2]-zval);
			}
		glEnable(GL_LIGHTING);
	glPopMatrix();

	glFlush();

	glXSwapBuffers (auxXDisplay(), auxXWindow());

	if (ccounter++ == 4) {
		note = choosenote(brrand() * psum);
		rrr->cmd("FMINST", 8, 0.0, 2.0, 7000.0, note, note-1.0, 0.0, 1.5, 0.0);
		rrr->cmd("FMINST", 8, 0.0, 2.0, 7000.0, note+(brrand()*0.002), note-1.0, 0.0, 1.5, 1.0);

		ccounter = 0;
		}
}


void myinit (void) 
{
	GLfloat diffuseMaterial[4];
	GLfloat light_position[] = { -1.0, 1.0, -1.0, 0.0 };

	glShadeModel(GL_SMOOTH);
	xval = 0.0;
	yval = 1.0;
	zval = 5.0;
	rval = 0.0;
	xincr = 0.0;
	yincr = 0.0;
	zincr = 0.0;
	rincr = 0.0;
	moveit = 0;
	ccounter = 0;

	pitches[0].octpc = 8.00;
	pitches[0].vvv[0] = 0.0;
	pitches[0].vvv[1] = 0.0;
	pitches[0].vvv[2] = 0.0;
	pitches[1].octpc = 8.07;
	pitches[1].vvv[0] = 6.0;
	pitches[1].vvv[1] = 0.0;
	pitches[1].vvv[2] = 0.0;
	pitches[2].octpc = 8.05;
	pitches[2].vvv[0] = 0.0;
	pitches[2].vvv[1] = 0.0;
	pitches[2].vvv[2] = -6.0;
	pitches[3].octpc = 8.02;
	pitches[3].vvv[0] = 6.0;
	pitches[3].vvv[1] = 0.0;
	pitches[3].vvv[2] = -6.0;
	pitches[4].octpc = 8.03;
	pitches[4].vvv[0] = 3.0;
	pitches[4].vvv[1] = 3.0;
	pitches[4].vvv[2] = -3.0;
	pitches[5].octpc = 7.10;
	pitches[5].vvv[0] = 3.0;
	pitches[5].vvv[1] = -3.0;
	pitches[5].vvv[2] = -3.0;

	glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuseMaterial);
	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);
}

void myReshape(int w, int h)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glViewport(0, 0, w, h);
	glLineWidth(1.0);
}

int main(int argc, char** argv)
{
	rrr = new RTcmix(44100.0, 2);
	sleep(1);
	rrr->cmd("load", 1, "FMINST");

	rrr->cmd("makegen", 9, 1.0, 24.0, 1000.0, 0.0, 0.0, 0.1, 1.0, 0.7, 0.0);
	rrr->cmd("makegen", 6, 2.0, 10.0, 1000.0, 1.0, 0.1, 0.35);
	rrr->cmd("makegen", 9, 3.0, 24.0, 1000.0, 0.0, 0.5, 0.2, 1.0, 0.7, 0.1);


	auxInitDisplayMode (AUX_DOUBLE | AUX_RGB);
	auxInitPosition (0, 0, 500, 500);
	auxInitWindow (argv[0]);
	myinit();

	auxKeyFunc (AUX_LEFT, xup);
	auxKeyFunc (AUX_RIGHT, xdown);
	auxKeyFunc (AUX_UP, zup);
	auxKeyFunc (AUX_DOWN, zdown);
	auxKeyFunc (AUX_u, yup);
	auxKeyFunc (AUX_d, ydown);
	auxKeyFunc (AUX_h, homest);
	auxKeyFunc (AUX_SPACE, movetoggle);
	auxMouseFunc(AUX_LEFTBUTTON, AUX_MOUSEDOWN, rleft);
	auxMouseFunc(AUX_RIGHTBUTTON, AUX_MOUSEDOWN, rright);
	auxMouseFunc(AUX_MIDDLEBUTTON, AUX_MOUSEDOWN, rstop);

	auxReshapeFunc (myReshape);
/*
	tv.tv_sec = 0;
	tv.tv_usec = 100000;
	itv.it_interval = tv;
	itv.it_value = tv;
	setitimer(ITIMER_REAL, &itv, NULL);
	sigset(SIGALRM, rdisplay);
*/

	RTtimeit(0.1, (sig_t)rdisplay);

	auxMainLoop(rdisplay);
}


float choosenote(float prob)
{
	float thenote;
	int i;

	for(i = 0; i < 6; i++) {
		if (prob < pitches[i].pprob) {
			thenote = pitches[i].octpc;
			i = 6;
			}
		}
	return(thenote);
}


long randx = 1;

void srrand(unsigned x)
{
	randx = x;
}

float brrand()
{
	int i = ((randx = randx*1103515245 + 12345)>>16) & 077777;
	return((float)i/32768.0);
}

